function merge(a, b)
    res = {}
    for k, v in pairs(b) do res[k] = v end
    for k, v in pairs(a) do res[#b + k] = v end
    return res
end

-- Leg looks like:
--
-- body -|alfa|- coxa -(beta)- femur -(gama)- tibia
--

legs = {"leg/fr", "leg/fl", "leg/rr", "leg/rl"}

alfas = {
    "leg/fr/alfa", "leg/fl/alfa", "leg/rr/alfa", "leg/rl/alfa"
}
betas = {
    "leg/fr/beta", "leg/fl/beta", "leg/rr/beta", "leg/rl/beta"
}
gamas = {
    "leg/fr/gama", "leg/fl/gama", "leg/rr/gama", "leg/rl/gama"
}

all = merge(alfas, merge(betas, gamas))

dirs = {{1, -1, 0}, {1, 1, 0}, {-1, -1, 0}, {-1, 1, 0}}

neutral_angles = {0.785, 3.1415, 3.1415}


log_file = io.open("./pid.csv", "w")

on_msg{key="SERVO", cb=function (msg)
   sid = msg[1]
   submsg = msg[2]
   subid = submsg[0]
   print(submsg)
   if subid ~= "TELEM" then
       return
   end
   log_file:write(get_system_time{},",",sid,",",submsg[1],",",submsg[2],",",submsg[3],"\n")
end}


function clamp(a, b, c)
	if a > c then
		return c
	end
	if a < b then
		return b
	end
	return a
end

