#include "fw/dynamixel/base.h"
#include "fw/lewan/base.h"

#include <bitset>
#include <schpin_lib_exp/overload.h>
#include <schpin_lib_exp/scaled.h>
#include <variant>

#pragma once

namespace schpin
{

enum class reply
{
        YES,
        NO
};

enum servo_task_enum : uint8_t
{
        TASK_GOTO,
        TASK_SPIN,
        TASK_IDLE,
        TASK_SPIN_UNTIL,
        TASK_ACTIVATE
};

struct full_buffer_tag
{
};

struct activate_tag
{
};

struct control_tag
{
};

struct servo_tag
{
};

enum servo_type_enum : uint8_t
{
        LEWAN_SERVO = 0,
        DYNMX_SERVO = 1
};

// TODO: this has to be strongly typed :/
using ctl_id   = uint16_t;
using s_ctl_id = uint16_t;
using checksum = uint16_t;

using servo_flags = std::bitset< 256 >;
using clk_time    = scaled< struct clock_time_tag, uint32_t, std::milli >;
using pid_gain    = scaled< struct pid_gain_tag, uint32_t, std::micro >;

using bangle            = scaled< struct bangle_tag, int16_t, std::milli >;
using btime             = scaled< struct btime_tag, int16_t, std::milli >;
using bangular_velocity = scaled< struct bangular_velocity_tag, int16_t, std::milli >;
using btemp             = scaled< struct btemp_tag, uint16_t, std::milli >;
using bvoltage          = scaled< struct bvoltage_tag, uint16_t, std::milli >;
using bfreq             = scaled< struct bfreq_tag, uint16_t, std::milli >;

// TODO: this has to be strongly typed :/ and definetly not uint16_t
using servo_id   = uint16_t;
using servo_addr = std::variant< lewan_servo_id, dynmx_servo_id >;

inline std::ostream& operator<<( std::ostream& os, const servo_addr& id )
{
        id << match( [&]( const auto& item ) {
                os << item;
        } );
        return os;
}

}  // namespace schpin
