#include "node/lua_vm.h"
#include "node/state_machines/boot.h"
#include "node/state_machines/simple.h"

#include <schpin_msgs/BlobCtl.h>

#pragma once

namespace schpin
{

class control_component
{
        using machine_variant = std::variant< idle_state_machine,
                                              boot_state_machine,
                                              lua_vm_machine,
                                              statelog_state_machine >;

        ros::NodeHandle    handle_;
        machine_variant    state_;
        ros::ServiceServer ctl_serv_;

      public:
        control_component( const ros::NodeHandle& handle, const node_context& context );

        bool on_ctl( schpin_msgs::BlobCtl::Request& req, schpin_msgs::BlobCtl::Response& res );

        void tick( const node_context& context, sm_feedback_f fb_fun );

        void on_feedback( const fw_node_group_variant& v,
                          const node_context&              context,
                          sm_feedback_f                    fb_fun );
};

}  // namespace schpin
