
#include "node/robot/model.h"

using namespace schpin;

em::either< robot_model, load_error > schpin::load_robot_model( const urdf::Model&      model,
                                                                const srdf_information& srdf_info )
{
        auto eithers = load_leg_models( model, srdf_info );

        partitioned_eithers< leg_model, load_error > parted =
            partition_eithers( std::move( eithers ) );

        if ( parted.right.empty() ) {
                return { robot_model{ std::move( parted.left ) } };
        }

        return E( load_error ).group_attach( parted.right ) << "Failed to load the robot_model";
}
