#include "node/lua_vm/def.h"

// TODO: this is fugly
//
// - refactor the printing

using namespace schpin;

void print_help( const nlohmann::json& j );

int main( int argc, char* argv[] )
{
        nlohmann::json res;
        em::for_each( slua_control_vm_def::get_def(), [&]( auto item ) {
                res.push_back( item );
        } );

        std::string output_type;

        if ( argc == 1 ) {
                output_type = "help";
        } else if ( argc == 2 ) {
                output_type = argv[1];
        } else {
                std::cerr << "You have to specificy either no argument, or output type: help, json";
                return 1;
        }

        if ( output_type == "help" ) {
                print_help( res );
        } else if ( output_type == "json" ) {
                std::cout << res;
        } else {
                std::cerr << "Unknown output type: " << output_type;
                return 1;
        }
        return 0;
}

void print_header( const nlohmann::json& j )
{
        std::cout << colorize( j["name"].get< std::string >(), term_color::CYAN );
        if ( j["type"] != "global variable" ) {
                std::cout << colorize( "{", term_color::CYAN );
        }
        if ( j.contains("arg") && j["arg"].contains( "args" ) ) {
                std::string delim = " ";
                for ( nlohmann::json args : j["arg"]["args"] ) {
                        for ( nlohmann::json key : args["keys"] ) {
                                std::cout << delim << key.get< std::string >();
                                delim = ", ";
                        }
                }
                std::cout << " ";
        }
        if ( j["type"] != "global variable" ) {
                std::cout << colorize( "}", term_color::CYAN );
        }

        std::cout << " " << colorize( "(" + j["type"].get< std::string >() + ")", term_color::GRAY )
                  << "\n";
}

std::string rjust( std::string inpt, std::size_t val )
{
        while ( inpt.size() < val ) {
                inpt += " ";
        }
        return inpt;
}

void wrap_print( std::string s, std::size_t len, std::string prefix )
{
        std::size_t i = s.rfind( " ", len );
        if ( i == std::string::npos || s.size() < len ) {
                std::cout << prefix << s << "\n";
                return;
        }

        std::cout << prefix << s.substr( 0, i ) << "\n";
        wrap_print( s.substr( i + 1 ), len, prefix );
}

void print_example( const nlohmann::json& j )
{
        if ( !j.contains( "example" ) ) {
                return;
        }
        std::cout << "    " << colorize( "example ", term_color::BLUE ) << "\n";
        std::cout << "        " << j["example"].get< std::string >() << "\n";
}

void print_args( const nlohmann::json& j )
{
        if ( j["type"] == "global variable" ) {
                return;
        }
        if ( !j.contains( "arg" ) || !j["arg"].contains( "args" ) ) {
                return;
        }

        for ( nlohmann::json arg : j["arg"]["args"] ) {
                std::cout << "    ";
                std::string delim = "";
                for ( nlohmann::json key : arg["keys"] ) {
                        std::cout << delim
                                  << colorize( key.get< std::string >(), term_color::MAGENTA );
                        delim = ", ";
                }
                std::cout << " "
                          << colorize( "(" + arg["type"].get< std::string >() + ")",
                                       term_color::GRAY )
                          << "\n";
                wrap_print( arg["desc"].get< std::string >(), 71, "        " );
        }
}

void print_res( const nlohmann::json& j )
{
        if ( !j.contains( "res" ) ) {
                return;
        }
        std::cout << "    " << colorize( "returns", term_color::YELLOW ) << " "
                  << colorize( "(" + j["res"]["type"].get< std::string >() + ")", term_color::GRAY )
                  << "\n";
        wrap_print( j["res"]["desc"].get< std::string >(), 71, "        " );
}

void print_desc( const nlohmann::json& j )
{
        if ( j["type"] == "global variable" ) {
                std::cout << "    " << colorize( "value", term_color::YELLOW ) << " "
                          << colorize( "(" + j["val_type"].get< std::string >() + ")",
                                       term_color::GRAY )
                          << "\n        " << j["val"].get< std::string >() << "\n";
        }
        std::cout << "\n";
        wrap_print( j["desc"].get< std::string >(), 75, "    " );
        std::cout << "\n";
}

void print_help( const nlohmann::json& j )
{
        for ( nlohmann::json item : j ) {
                std::cout << "\n";
                print_header( item );
                print_args( item );
                print_res( item );
                print_desc( item );
                print_example( item );
                std::cout << "\n";
        }
}
