#include "schpin_lib/color.h"
#include "schpin_lib/geom/pose.h"

#include <urdf/model.h>
#include <urdf_model/joint.h>
#include <urdf_model/link.h>
#pragma once

namespace schpin
{

inline color convert_urdf_color( urdf::Color c )
{
        return color{c.r, c.g, c.b};
}

template < typename Tag >
inline point< 3, Tag > convert_urdf_point( urdf::Vector3 v )
{
        return point< 3, Tag >{float( v.x ), float( v.y ), float( v.z )};
}

template < typename Tag >
inline quaternion< Tag > convert_urdf_quaternion( urdf::Rotation r )
{
        return quaternion< Tag >{float( r.x ), float( r.y ), float( r.z ), float( r.w )};
}

template < typename Tag >
inline pose< Tag > convert_urdf_pose( urdf::Pose p )
{
        return pose< Tag >{convert_urdf_point< Tag >( p.position ),
                           convert_urdf_quaternion< Tag >( p.rotation )};
}
}  // namespace schpin
