#include <nlohmann/json.hpp>

#pragma once

template < typename AStarConfig >
struct nlohmann::adl_serializer< schpin::a_star< AStarConfig > >
{

        static void to_json( nlohmann::json& j, const schpin::a_star< AStarConfig >& astar )
        {
                j["graph"] = *astar;
        }
        static schpin::a_star< AStarConfig > from_json( const nlohmann::json& j )
        {
                using graph              = typename AStarConfig::Graph;
                using heuristic_function = typename AStarConfig::heuristic_function;
                return schpin::a_star< AStarConfig >( j.at( "graph" ).get< graph >(),
                                                      heuristic_function() );
        }
};
