#include <nlohmann/json.hpp>

#pragma once

template < typename DStarConfig >
struct nlohmann::adl_serializer< schpin::d_star< DStarConfig > >
{

        static void to_json( nlohmann::json& j, const schpin::d_star< DStarConfig >& dstar )
        {
                j["graph"] = *dstar;
        }
        static schpin::d_star< DStarConfig > from_json( const nlohmann::json& j )
        {
                using graph              = typename DStarConfig::graph;
                using heuristic_function = typename DStarConfig::heuristic_function;
                return schpin::d_star< DStarConfig >( j.at( "graph" ).get< graph >(),
                                                      heuristic_function() );
        }
};
